##parameters=REQUEST
# $Id: apply_admission.py 173 2005-11-15 16:28:29Z joachim $
"""
process the Application Form
return html renderer + psm
"""
import DateTime
current = DateTime.DateTime()

type_name = 'StudentApplication'

ti = context.portal_types[type_name]

REQUEST.set('type_name',type_name)

validate = REQUEST.has_key("cpsdocument_edit_button")


lt = context.portal_layouts
pr = context.portal_registration

res,psm,ds = lt.renderLayout(layout_id= 'student_check_pin',
                      schema_id= 'student_application',
                      context=context,
                      mapping=validate and REQUEST,
                      ob={},
                      layout_mode='create',
                      formaction = "apply_admission",
                      submit = "check",
                      )
if psm == 'invalid':
    return context.application_pin_form(rendered = res,
                                 psm = "Please correct your input",
                                 ds = ds,
                                 )
elif psm == '':
    return context.application_pin_form(rendered = res,
                                 psm = None,
                                 ds = ds,
                                 )
elif psm == 'valid':
    jamb_id = ds.get('jamb_id')
    catalog = context.portal_catalog
    search = catalog({'meta_type': 'StudentApplication',
                     'jamb_reg_no': jamb_id
                     })

    if len(search) < 1:
        psm = "No JAMB record %s" % (jamb_id)
        return context.application_pin_form(rendered = res,
                                 psm = psm,
                                 ds = ds,
                                 )
application = search[0].getObject()
student = application.aq_parent
student.invokeFactory('StudentClearance','clearance')
student.invokeFactory('StudentPersonal','personal')
# now display the passport form with jamb-data readonly
return student.application_form()


